import { BasePart } from './BasePart';
export class ArrayPart extends BasePart {
    constructor(config, path) {
        super(config, path);
        const Component = this.options.content.type;
        this._child = new Component(this.options.content);
    }
    process(data) {
        const value = super.process(data);
        if (value && Array.isArray(value)) {
            return value.map((data) => {
                return this._child.process(data);
            });
        }
        else {
            return value;
        }
    }
    getValue(data) {
        if (Array.isArray(data)) {
            return data;
        }
        else {
            return null;
        }
    }
}
//# sourceMappingURL=ArrayPart.js.map