import { BasePart } from './BasePart';
export class DatePart extends BasePart {
    getValue(data) {
        if (data == null) {
            return data;
        }
        switch (typeof data) {
            case 'object':
            case 'string':
            case 'number':
                return DatePart._returnValidDate(data);
            default:
                return null;
        }
    }
    isValid(data) {
        return !data || data instanceof Date && !isNaN(data.getTime());
    }
    static _returnValidDate(date) {
        if (typeof date === 'object') {
            if (date instanceof Date) {
                return date;
            }
            else {
                return null;
            }
        }
        return new Date(date);
    }
}
//# sourceMappingURL=DatePart.js.map