import { BasePart } from './BasePart';
import { isObject } from './utils';
export class ObjectPart extends BasePart {
    constructor(config, path) {
        super(config, path);
        const myPath = this.getPath();
        this._childHash = Object.create(null);
        Object.entries(this.options.content).forEach(([key, config]) => {
            const Component = config.type;
            const localPath = path == null ? String(key) : `${myPath}.${key}`;
            this._childHash[key] = new Component(config, localPath);
        });
    }
    process(data) {
        const value = super.process(data);
        if (value && isObject(value)) {
            const result = Object.create(null);
            Object.keys(this._childHash).forEach((name) => {
                result[name] = this._childHash[name].process(data);
            });
            return result;
        }
        else {
            return value;
        }
    }
    getValue(data) {
        if (isObject(data)) {
            return data;
        }
        else {
            return [];
        }
    }
}
//# sourceMappingURL=ObjectPart.js.map